#ifndef STARS_IRDB_Function_h
#define STARS_IRDB_Function_h

#include "interfaces/STARSTypes.h"

class SMPFunction;

class STARS_IRDB_Function_t : public STARS_Function_t 
{
public:

	// obvious
        virtual char* GetFunctionName(const char* name, const int len) const =0;

	// get entry point of function
        virtual STARS_ea_t get_startEA()=0;

	// clc needs to review and get back to me.
        virtual STARS_ea_t get_endEA()=0;

	// init class-local variable with IRDB value
	// and these are accessors to that.
	virtual std::size_t GetFrameSize()=0;
	virtual void SetFrameSize(std::size_t size) = 0;

	// todo for clc: audit these functions and see if they are really getting info from idapro
	// or if these can be removed from the interface because they are calculated by STARS 
	// interface-independent routines.
	virtual std::size_t GetSavedRegSize() = 0;
	virtual std::size_t GetIncomingArgumentSize() = 0;
	virtual std::size_t GetFrameReturnAddressSize() = 0;



        virtual bool FunctionUsesFP()=0;
        virtual bool IsStaticFunction()=0;
        virtual bool IsLibraryFunction()=0;
        virtual bool IsStackPointerAnalyzed()=0;
	virtual STARS_sval_t get_spd(STARS_ea_t ea)=0;
	virtual bool HasReturnPoints()=0;
	virtual bool IsMultiEntry()=0;
	virtual void MarkSharedChunks()=0;
	virtual bool HasSharedChunks() const =0;
	virtual void SetSharedChunks(bool v) =0;
        virtual void UpdateXrefs()=0;
	virtual void BuildFuncIR(SMPFunction *func)=0;
        virtual bool FindDistantCodeFragment(SMPFunction* func, STARS_ea_t TargetAddr)=0;
	virtual void FillInLocalVarTable(SMPFunction *CurrFunc) = 0; // get stack frame fine-grained info
	virtual bool AnalyzeInstAsCallTarget(SMPFunction *CurrFunc, bool &IsIndirectCallTarget, bool &IsTailCallTarget) = 0; // return success or failure of analysis
	virtual bool IsChunkUnshared(STARS_ea_t ChunkAddr, STARS_ea_t FuncHeadStart, STARS_ea_t FuncHeadEnd) = 0;

};

#endif
