#ifndef STARSIRDBSegment_h
#define STARSIRDBSegment_h


#include "interfaces/STARSTypes.h"
#include "elfio/elfio.hpp"


/* 
 * There is some terminology mismatch between IDA's use of 
 * "segment" and ELF's use of "segment".
 * This file will inherently be confusing as both uses are in play. 
 */
class STARS_IRDB_Segment_t : public STARS_Segment_t
{
	public:
		STARS_IRDB_Segment_t(ELFIO::section* seg, int p_segno) : the_seg(seg), segno(p_segno) {}
        	virtual STARS_ea_t get_startEA()
		{ return the_seg->get_virtual_address(); }
        	virtual STARS_ea_t get_endEA()
		{ return the_seg->get_virtual_address()+the_seg->get_size(); }
        	virtual bool IsCodeSegment()  { assert(0); /* perms include x */ }
        	virtual bool IsXternSegment() { assert(0); /* return false" */}
        	virtual bool IsDataSegment() { assert(0); /* rw */}
        	virtual bool IsCommonSegment() { assert(0); /* leave as error */}
        	virtual bool IsBSSSegment() { assert(0); /* NOBITS */ }
        	virtual bool IsReadableSegment() { assert(0); }
        	virtual bool IsWriteableSegment() { assert(0); }
		virtual STARS_ssize_t GetSegmentName(char* name, int len) { assert(0); }

		virtual int GetSegmentNumber() { return segno; }

	private:
		ELFIO::section* the_seg;
		int segno;
		
};

#endif
